/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.243 Revision 1.349
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.243 2006/07/05 01:16:18 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.349 2010/08/19 21:32:26 vapier Exp $
4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
4# 14#
5# This eclass is for general purpose functions that most ebuilds 15# Due to the nature of this eclass, some functions may have maintainers
6# have to implement themselves. 16# different from the overall eclass!
7#
8# NB: If you add anything, please comment it!
9#
10# Maintainer: see each individual function, base-system@gentoo.org as default
11 17
12inherit multilib portability 18inherit multilib portability
13 19
14DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
15 21
16# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
17# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
18# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
19# must be an integer greater than zero. 25# @USAGE: [seconds]
20# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
21epause() { 31epause() {
22 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
23 sleep ${1:-5}
24 fi
25} 33}
26 34
27# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
28# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
29# don't beep. 37# @DESCRIPTION:
30# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
31ebeep() { 42ebeep() {
32 local n 43 local n
33 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
34 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
35 echo -ne "\a" 46 echo -ne "\a"
36 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
37 echo -ne "\a" 48 echo -ne "\a"
38 sleep 1 49 sleep 1
39 done 50 done
40 fi 51 fi
41} 52}
42 53
43# This function generate linker scripts in /usr/lib for dynamic 54else
44# libs in /lib. This is to fix linking problems when you have
45# the .so in /lib, and the .a in /usr/lib. What happens is that
46# in some cases when linking dynamic, the .a in /usr/lib is used
47# instead of the .so in /lib due to gcc/libtool tweaking ld's
48# library search path. This cause many builds to fail.
49# See bug #4411 for more info.
50#
51# To use, simply call:
52#
53# gen_usr_ldscript libfoo.so
54#
55# Note that you should in general use the unversioned name of
56# the library, as ldconfig should usually update it correctly
57# to point to the latest version of the library present.
58#
59# <azarah@gentoo.org> (26 Oct 2002)
60#
61gen_usr_ldscript() {
62 local lib libdir=$(get_libdir)
63 # Just make sure it exists
64 dodir /usr/${libdir}
65 55
66 for lib in "${@}" ; do 56ebeep() {
67 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
68 /* GNU ld script 58}
69 Since Gentoo has critical dynamic libraries
70 in /lib, and the static versions in /usr/lib,
71 we need to have a "fake" dynamic lib in /usr/lib,
72 otherwise we run into linking problems.
73 59
74 See bug http://bugs.gentoo.org/4411 for more info. 60epause() {
75 */ 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
76 GROUP ( /${libdir}/${lib} ) 62}
77 END_LDSCRIPT 63
78 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
75fi
76
77# @FUNCTION: ecvs_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove CVS directories recursiveley. Useful when a source tarball contains
81# internal CVS directories. Defaults to $PWD.
82ecvs_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
85 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
86}
87
88# @FUNCTION: esvn_clean
89# @USAGE: [list of dirs]
90# @DESCRIPTION:
91# Remove .svn directories recursiveley. Useful when a source tarball contains
92# internal Subversion directories. Defaults to $PWD.
93esvn_clean() {
94 [[ -z $* ]] && set -- .
95 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
96}
97
98# @FUNCTION: eshopts_push
99# @USAGE: [options to `set` or `shopt`]
100# @DESCRIPTION:
101# Often times code will want to enable a shell option to change code behavior.
102# Since changing shell options can easily break other pieces of code (which
103# assume the default state), eshopts_push is used to (1) push the current shell
104# options onto a stack and (2) pass the specified arguments to set.
105#
106# If the first argument is '-s' or '-u', we assume you want to call `shopt`
107# rather than `set` as there are some options only available via that.
108#
109# A common example is to disable shell globbing so that special meaning/care
110# may be used with variables/arguments to custom functions. That would be:
111# @CODE
112# eshopts_push -o noglob
113# for x in ${foo} ; do
114# if ...some check... ; then
115# eshopts_pop
116# return 0
117# fi
79 done 118# done
119# eshopts_pop
120# @CODE
121eshopts_push() {
122 # have to assume __ESHOPTS_SAVE__ isn't screwed with
123 # as a `declare -a` here will reset its value
124 local i=${#__ESHOPTS_SAVE__[@]}
125 if [[ $1 == -[su] ]] ; then
126 __ESHOPTS_SAVE__[$i]=$(shopt -p)
127 [[ $# -eq 0 ]] && return 0
128 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
129 else
130 __ESHOPTS_SAVE__[$i]=$-
131 [[ $# -eq 0 ]] && return 0
132 set "$@" || die "eshopts_push: bad options to set: $*"
133 fi
80} 134}
81 135
136# @FUNCTION: eshopts_pop
137# @USAGE:
138# @DESCRIPTION:
139# Restore the shell options to the state saved with the corresponding
140# eshopts_push call. See that function for more details.
141eshopts_pop() {
142 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
143 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
144 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
145 local s=${__ESHOPTS_SAVE__[$i]}
146 unset __ESHOPTS_SAVE__[$i]
147 if [[ ${s} == "shopt -"* ]] ; then
148 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
149 else
150 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
151 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
152 fi
153}
82 154
83# Default directory where patches are located 155# @VARIABLE: EPATCH_SOURCE
156# @DESCRIPTION:
157# Default directory to search for patches.
84EPATCH_SOURCE="${WORKDIR}/patch" 158EPATCH_SOURCE="${WORKDIR}/patch"
85# Default extension for patches 159# @VARIABLE: EPATCH_SUFFIX
160# @DESCRIPTION:
161# Default extension for patches (do not prefix the period yourself).
86EPATCH_SUFFIX="patch.bz2" 162EPATCH_SUFFIX="patch.bz2"
163# @VARIABLE: EPATCH_OPTS
164# @DESCRIPTION:
87# Default options for patch 165# Default options for patch:
166# @CODE
88# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 167# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
89# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 168# --no-backup-if-mismatch - do not leave .orig files behind
90# Set -E to automatically remove empty files. 169# -E - automatically remove empty files
170# @CODE
91EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 171EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
172# @VARIABLE: EPATCH_EXCLUDE
173# @DESCRIPTION:
92# List of patches not to apply. Not this is only file names, 174# List of patches not to apply. Note this is only file names,
93# and not the full path .. 175# and not the full path. Globs accepted.
94EPATCH_EXCLUDE="" 176EPATCH_EXCLUDE=""
177# @VARIABLE: EPATCH_SINGLE_MSG
178# @DESCRIPTION:
95# Change the printed message for a single patch. 179# Change the printed message for a single patch.
96EPATCH_SINGLE_MSG="" 180EPATCH_SINGLE_MSG=""
181# @VARIABLE: EPATCH_MULTI_MSG
182# @DESCRIPTION:
97# Change the printed message for multiple patches. 183# Change the printed message for multiple patches.
98EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 184EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
99# Force applying bulk patches even if not following the style: 185# @VARIABLE: EPATCH_FORCE
100# 186# @DESCRIPTION:
101# ??_${ARCH}_foo.${EPATCH_SUFFIX} 187# Only require patches to match EPATCH_SUFFIX rather than the extended
102# 188# arch naming style.
103EPATCH_FORCE="no" 189EPATCH_FORCE="no"
104 190
105# This function is for bulk patching, or in theory for just one 191# @FUNCTION: epatch
106# or two patches. 192# @USAGE: [patches] [dirs of patches]
193# @DESCRIPTION:
194# epatch is designed to greatly simplify the application of patches. It can
195# process patch files directly, or directories of patches. The patches may be
196# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
197# the -p option as epatch will automatically attempt -p0 to -p5 until things
198# apply successfully.
107# 199#
108# It should work with .bz2, .gz, .zip and plain text patches. 200# If you do not specify any options, then epatch will default to the directory
109# Currently all patches should be the same format. 201# specified by EPATCH_SOURCE.
110# 202#
111# You do not have to specify '-p' option to patch, as it will 203# When processing directories, epatch will apply all patches that match:
112# try with -p0 to -p5 until it succeed, or fail at -p5. 204# @CODE
113# 205# ${EPATCH_FORCE} == "yes"
114# Above EPATCH_* variables can be used to control various defaults,
115# bug they should be left as is to ensure an ebuild can rely on
116# them for.
117#
118# Patches are applied in current directory.
119#
120# Bulk Patches should preferibly have the form of:
121#
122# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else
208# *.${EPATCH_SUFFIX}
209# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering.
211# The arch field is used to apply patches only for the host architecture with
212# the special value of "all" means apply for everyone. Note that using values
213# other than "all" is highly discouraged -- you should apply patches all the
214# time and let architecture details be detected at configure/compile time.
123# 215#
124# For example: 216# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
217# for patches to apply.
125# 218#
126# 01_all_misc-fix.patch.bz2 219# Refer to the other EPATCH_xxx variables for more customization of behavior.
127# 02_sparc_another-fix.patch.bz2
128#
129# This ensures that there are a set order, and you can have ARCH
130# specific patches.
131#
132# If you however give an argument to epatch(), it will treat it as a
133# single patch that need to be applied if its a file. If on the other
134# hand its a directory, it will set EPATCH_SOURCE to this.
135#
136# <azarah@gentoo.org> (10 Nov 2002)
137#
138epatch() { 220epatch() {
139 _epatch_draw_line() { 221 _epatch_draw_line() {
222 # create a line of same length as input string
140 [[ -z $1 ]] && set "$(printf "%65s" '')" 223 [[ -z $1 ]] && set "$(printf "%65s" '')"
141 echo "${1//?/=}" 224 echo "${1//?/=}"
142 } 225 }
143 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
144 local PIPE_CMD=""
145 local STDERR_TARGET="${T}/$$.out"
146 local PATCH_TARGET="${T}/$$.patch"
147 local PATCH_SUFFIX=""
148 local SINGLE_PATCH="no"
149 local x=""
150 226
151 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 227 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
152 228
153 if [ "$#" -gt 1 ] 229 # Let the rest of the code process one user arg at a time --
154 then 230 # each arg may expand into multiple patches, and each arg may
231 # need to start off with the default global EPATCH_xxx values
232 if [[ $# -gt 1 ]] ; then
155 local m="" 233 local m
156 for m in "$@" ; do 234 for m in "$@" ; do
157 epatch "${m}" 235 epatch "${m}"
158 done 236 done
159 return 0 237 return 0
160 fi 238 fi
161 239
162 if [ -n "$1" -a -f "$1" ] 240 local SINGLE_PATCH="no"
163 then 241 # no args means process ${EPATCH_SOURCE}
242 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
243
244 if [[ -f $1 ]] ; then
164 SINGLE_PATCH="yes" 245 SINGLE_PATCH="yes"
165 246 set -- "$1"
166 local EPATCH_SOURCE="$1" 247 # Use the suffix from the single patch (localize it); the code
248 # below will find the suffix for us
167 local EPATCH_SUFFIX="${1##*\.}" 249 local EPATCH_SUFFIX=$1
168 250
169 elif [ -n "$1" -a -d "$1" ] 251 elif [[ -d $1 ]] ; then
170 then 252 # Some people like to make dirs of patches w/out suffixes (vim)
171 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
172 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 254
255 else
256 # sanity check ... if it isn't a dir or file, wtf man ?
257 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
258 echo
259 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
260 eerror
261 eerror " ${EPATCH_SOURCE}"
262 eerror " ( ${EPATCH_SOURCE##*/} )"
263 echo
264 die "Cannot find \$EPATCH_SOURCE!"
265 fi
266
267 local PIPE_CMD
268 case ${EPATCH_SUFFIX##*\.} in
269 xz) PIPE_CMD="xz -dc" ;;
270 lzma) PIPE_CMD="lzma -dc" ;;
271 bz2) PIPE_CMD="bzip2 -dc" ;;
272 gz|Z|z) PIPE_CMD="gzip -dc" ;;
273 ZIP|zip) PIPE_CMD="unzip -p" ;;
274 *) ;;
275 esac
276
277 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
278
279 local x
280 for x in "$@" ; do
281 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
282 # didn't match anything, ignore continue on
283 [[ ! -f ${x} ]] && continue
284
285 local patchname=${x##*/}
286
287 # Apply single patches, or forced sets of patches, or
288 # patches with ARCH dependant names.
289 # ???_arch_foo.patch
290 # Else, skip this input altogether
291 local a=${patchname#*_} # strip the ???_
292 a=${a%%_*} # strip the _foo.patch
293 if ! [[ ${SINGLE_PATCH} == "yes" || \
294 ${EPATCH_FORCE} == "yes" || \
295 ${a} == all || \
296 ${a} == ${ARCH} ]]
173 then 297 then
174 local EPATCH_SOURCE="$1/*" 298 continue
299 fi
300
301 # Let people filter things dynamically
302 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
303 # let people use globs in the exclude
304 eshopts_push -o noglob
305
306 local ex
307 for ex in ${EPATCH_EXCLUDE} ; do
308 if [[ ${patchname} == ${ex} ]] ; then
309 eshopts_pop
310 continue 2
311 fi
312 done
313
314 eshopts_pop
315 fi
316
317 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
318 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
319 einfo "${EPATCH_SINGLE_MSG}"
320 else
321 einfo "Applying ${patchname} ..."
322 fi
175 else 323 else
176 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 324 einfo " ${patchname} ..."
177 fi 325 fi
178 else 326
179 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 327 # most of the time, there will only be one run per unique name,
180 then 328 # but if there are more, make sure we get unique log filenames
181 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 329 local STDERR_TARGET="${T}/${patchname}.out"
182 then 330 if [[ -e ${STDERR_TARGET} ]] ; then
183 EPATCH_SOURCE="$1" 331 STDERR_TARGET="${T}/${patchname}-$$.out"
332 fi
333
334 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
335
336 # Decompress the patch if need be
337 local count=0
338 local PATCH_TARGET
339 if [[ -n ${PIPE_CMD} ]] ; then
340 PATCH_TARGET="${T}/$$.patch"
341 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
342
343 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
344 echo
345 eerror "Could not extract patch!"
346 #die "Could not extract patch!"
347 count=5
348 break
184 fi 349 fi
350 else
351 PATCH_TARGET=${x}
352 fi
185 353
354 # Check for absolute paths in patches. If sandbox is disabled,
355 # people could (accidently) patch files in the root filesystem.
356 # Or trigger other unpleasantries #237667. So disallow -p0 on
357 # such patches.
358 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
359 if [[ -n ${abs_paths} ]] ; then
360 count=1
361 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
362 fi
363
364 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
365 while [[ ${count} -lt 5 ]] ; do
366 # Generate some useful debug info ...
367 (
368 _epatch_draw_line "***** ${patchname} *****"
186 echo 369 echo
187 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 370 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
371 echo
372 _epatch_draw_line "***** ${patchname} *****"
373 ) >> "${STDERR_TARGET}"
374
375 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
376 (
377 _epatch_draw_line "***** ${patchname} *****"
378 echo
379 echo "ACTUALLY APPLYING ${patchname} ..."
380 echo
381 _epatch_draw_line "***** ${patchname} *****"
382 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
383 ) >> "${STDERR_TARGET}"
384
385 if [ $? -ne 0 ] ; then
386 echo
387 eerror "A dry-run of patch command succeeded, but actually"
388 eerror "applying the patch failed!"
389 #die "Real world sux compared to the dreamworld!"
390 count=5
391 fi
392 break
393 fi
394
395 : $(( count++ ))
396 done
397
398 # if we had to decompress the patch, delete the temp one
399 if [[ -n ${PIPE_CMD} ]] ; then
400 rm -f "${PATCH_TARGET}"
401 fi
402
403 if [[ ${count} -ge 5 ]] ; then
404 echo
405 eerror "Failed Patch: ${patchname} !"
406 eerror " ( ${PATCH_TARGET} )"
188 eerror 407 eerror
189 eerror " ${EPATCH_SOURCE}" 408 eerror "Include in your bugreport the contents of:"
190 eerror " ( ${EPATCH_SOURCE##*/} )" 409 eerror
410 eerror " ${STDERR_TARGET}"
191 echo 411 echo
192 die "Cannot find \$EPATCH_SOURCE!"
193 fi
194
195 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
196 fi
197
198 case ${EPATCH_SUFFIX##*\.} in
199 bz2)
200 PIPE_CMD="bzip2 -dc"
201 PATCH_SUFFIX="bz2"
202 ;;
203 gz|Z|z)
204 PIPE_CMD="gzip -dc"
205 PATCH_SUFFIX="gz"
206 ;;
207 ZIP|zip)
208 PIPE_CMD="unzip -p"
209 PATCH_SUFFIX="zip"
210 ;;
211 *)
212 PIPE_CMD="cat"
213 PATCH_SUFFIX="patch"
214 ;;
215 esac
216
217 if [ "${SINGLE_PATCH}" = "no" ]
218 then
219 einfo "${EPATCH_MULTI_MSG}"
220 fi
221 for x in ${EPATCH_SOURCE}
222 do
223 # New ARCH dependant patch naming scheme ...
224 #
225 # ???_arch_foo.patch
226 #
227 if [ -f ${x} ] && \
228 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
229 [ "${EPATCH_FORCE}" = "yes" ])
230 then
231 local count=0
232 local popts="${EPATCH_OPTS}"
233 local patchname=${x##*/}
234
235 if [ -n "${EPATCH_EXCLUDE}" ]
236 then
237 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
238 then
239 continue
240 fi
241 fi
242
243 if [ "${SINGLE_PATCH}" = "yes" ]
244 then
245 if [ -n "${EPATCH_SINGLE_MSG}" ]
246 then
247 einfo "${EPATCH_SINGLE_MSG}"
248 else
249 einfo "Applying ${patchname} ..."
250 fi
251 else
252 einfo " ${patchname} ..."
253 fi
254
255 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
256 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
257
258 # Allow for prefix to differ ... im lazy, so shoot me :/
259 while [ "${count}" -lt 5 ]
260 do
261 # Generate some useful debug info ...
262 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
264
265 if [ "${PATCH_SUFFIX}" != "patch" ]
266 then
267 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
268 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
269 else
270 PATCH_TARGET="${x}"
271 fi
272
273 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
274 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275
276 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
277 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
278
279 if [ "${PATCH_SUFFIX}" != "patch" ]
280 then
281 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
282 then
283 echo
284 eerror "Could not extract patch!"
285 #die "Could not extract patch!"
286 count=5
287 break
288 fi
289 fi
290
291 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
292 then
293 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
294 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
295 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
297 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
298
299 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
300 _epatch_assert
301
302 if [ "$?" -ne 0 ]
303 then
304 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
305 echo
306 eerror "A dry-run of patch command succeeded, but actually"
307 eerror "applying the patch failed!"
308 #die "Real world sux compared to the dreamworld!"
309 count=5
310 fi
311
312 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
313
314 break
315 fi
316
317 count=$((count + 1))
318 done
319
320 if [ "${PATCH_SUFFIX}" != "patch" ]
321 then
322 rm -f ${PATCH_TARGET}
323 fi
324
325 if [ "${count}" -eq 5 ]
326 then
327 echo
328 eerror "Failed Patch: ${patchname} !"
329 eerror " ( ${PATCH_TARGET} )"
330 eerror
331 eerror "Include in your bugreport the contents of:"
332 eerror
333 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
334 echo
335 die "Failed Patch: ${patchname}!" 412 die "Failed Patch: ${patchname}!"
336 fi 413 fi
337 414
338 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 415 # if everything worked, delete the patch log
339 416 rm -f "${STDERR_TARGET}"
340 eend 0 417 eend 0
341 fi
342 done 418 done
343 if [ "${SINGLE_PATCH}" = "no" ] 419
344 then 420 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
345 einfo "Done with patching" 421 : # everything worked
422}
423epatch_user() {
424 [[ $# -ne 0 ]] && die "epatch_user takes no options"
425
426 # don't clobber any EPATCH vars that the parent might want
427 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
428 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
429 EPATCH_SOURCE=${base}/${CTARGET}/${check}
430 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
431 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
432 if [[ -d ${EPATCH_SOURCE} ]] ; then
433 EPATCH_SOURCE=${EPATCH_SOURCE} \
434 EPATCH_SUFFIX="patch" \
435 EPATCH_FORCE="yes" \
436 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
437 epatch
438 return 0
346 fi 439 fi
440 done
441 return 1
347} 442}
348 443
444# @FUNCTION: emktemp
445# @USAGE: [temp dir]
446# @DESCRIPTION:
349# Cheap replacement for when debianutils (and thus mktemp) 447# Cheap replacement for when debianutils (and thus mktemp)
350# does not exist on the users system 448# does not exist on the users system.
351# vapier@gentoo.org
352#
353# Takes just 1 optional parameter (the directory to create tmpfile in)
354emktemp() { 449emktemp() {
355 local exe="touch" 450 local exe="touch"
356 [[ $1 == -d ]] && exe="mkdir" && shift 451 [[ $1 == -d ]] && exe="mkdir" && shift
357 local topdir=$1 452 local topdir=$1
358 453
360 [[ -z ${T} ]] \ 455 [[ -z ${T} ]] \
361 && topdir="/tmp" \ 456 && topdir="/tmp" \
362 || topdir=${T} 457 || topdir=${T}
363 fi 458 fi
364 459
365 if [[ -z $(type -p mktemp) ]] ; then 460 if ! type -P mktemp > /dev/null ; then
461 # system lacks `mktemp` so we have to fake it
366 local tmp=/ 462 local tmp=/
367 while [[ -e ${tmp} ]] ; do 463 while [[ -e ${tmp} ]] ; do
368 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 464 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
369 done 465 done
370 ${exe} "${tmp}" || ${exe} -p "${tmp}" 466 ${exe} "${tmp}" || ${exe} -p "${tmp}"
371 echo "${tmp}" 467 echo "${tmp}"
372 else 468 else
469 # the args here will give slightly wierd names on BSD,
470 # but should produce a usable file on all userlands
373 if [[ ${exe} == "touch" ]] ; then 471 if [[ ${exe} == "touch" ]] ; then
374 [[ ${USERLAND} == "GNU" ]] \
375 && mktemp -p "${topdir}" \
376 || TMPDIR="${topdir}" mktemp -t tmp 472 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
377 else 473 else
378 [[ ${USERLAND} == "GNU" ]] \
379 && mktemp -d "${topdir}" \
380 || TMPDIR="${topdir}" mktemp -dt tmp 474 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
381 fi
382 fi 475 fi
476 fi
383} 477}
384 478
479# @FUNCTION: egetent
480# @USAGE: <database> <key>
481# @MAINTAINER:
482# base-system@gentoo.org (Linux)
483# Joe Jezak <josejx@gmail.com> (OS X)
484# usata@gentoo.org (OS X)
485# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
486# @DESCRIPTION:
385# Small wrapper for getent (Linux), nidump (Mac OS X), 487# Small wrapper for getent (Linux),
488# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
386# and pw (FreeBSD) used in enewuser()/enewgroup() 489# and pw (FreeBSD) used in enewuser()/enewgroup()
387# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
388# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
389#
390# egetent(database, key)
391egetent() { 490egetent() {
392 case ${CHOST} in 491 case ${CHOST} in
393 *-darwin*) 492 *-darwin[678])
394 case "$2" in 493 case "$2" in
395 *[!0-9]*) # Non numeric 494 *[!0-9]*) # Non numeric
396 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 495 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
397 ;; 496 ;;
398 *) # Numeric 497 *) # Numeric
399 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 498 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
499 ;;
500 esac
501 ;;
502 *-darwin*)
503 local mytype=$1
504 [[ "passwd" == $mytype ]] && mytype="Users"
505 [[ "group" == $mytype ]] && mytype="Groups"
506 case "$2" in
507 *[!0-9]*) # Non numeric
508 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
509 ;;
510 *) # Numeric
511 local mykey="UniqueID"
512 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
513 dscl . -search /$mytype $mykey $2 2>/dev/null
400 ;; 514 ;;
401 esac 515 esac
402 ;; 516 ;;
403 *-freebsd*|*-dragonfly*) 517 *-freebsd*|*-dragonfly*)
404 local opts action="user" 518 local opts action="user"
419 getent "$1" "$2" 533 getent "$1" "$2"
420 ;; 534 ;;
421 esac 535 esac
422} 536}
423 537
424# Simplify/standardize adding users to the system 538# @FUNCTION: enewuser
425# vapier@gentoo.org 539# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
426# 540# @DESCRIPTION:
427# enewuser(username, uid, shell, homedir, groups, extra options) 541# Same as enewgroup, you are not required to understand how to properly add
428# 542# a user to the system. The only required parameter is the username.
429# Default values if you do not specify any: 543# Default uid is (pass -1 for this) next available, default shell is
430# username: REQUIRED ! 544# /bin/false, default homedir is /dev/null, there are no default groups,
431# uid: next available (see useradd(8)) 545# and default params sets the comment as 'added by portage for ${PN}'.
432# note: pass -1 to get default behavior
433# shell: /bin/false
434# homedir: /dev/null
435# groups: none
436# extra: comment of 'added by portage for ${PN}'
437enewuser() { 546enewuser() {
438 case ${EBUILD_PHASE} in 547 case ${EBUILD_PHASE} in
439 unpack|compile|test|install) 548 unpack|compile|test|install)
440 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 549 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
441 eerror "Package fails at QA and at life. Please file a bug." 550 eerror "Package fails at QA and at life. Please file a bug."
448 eerror "No username specified !" 557 eerror "No username specified !"
449 die "Cannot call enewuser without a username" 558 die "Cannot call enewuser without a username"
450 fi 559 fi
451 560
452 # lets see if the username already exists 561 # lets see if the username already exists
453 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then 562 if [[ -n $(egetent passwd "${euser}") ]] ; then
454 return 0 563 return 0
455 fi 564 fi
456 einfo "Adding user '${euser}' to your system ..." 565 einfo "Adding user '${euser}' to your system ..."
457 566
458 # options to pass to useradd 567 # options to pass to useradd
459 local opts= 568 local opts=
460 569
461 # handle uid 570 # handle uid
462 local euid=$1; shift 571 local euid=$1; shift
463 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then 572 if [[ -n ${euid} && ${euid} != -1 ]] ; then
464 if [[ ${euid} -gt 0 ]] ; then 573 if [[ ${euid} -gt 0 ]] ; then
465 if [[ ! -z $(egetent passwd ${euid}) ]] ; then 574 if [[ -n $(egetent passwd ${euid}) ]] ; then
466 euid="next" 575 euid="next"
467 fi 576 fi
468 else 577 else
469 eerror "Userid given but is not greater than 0 !" 578 eerror "Userid given but is not greater than 0 !"
470 die "${euid} is not a valid UID" 579 die "${euid} is not a valid UID"
471 fi 580 fi
472 else 581 else
473 euid="next" 582 euid="next"
474 fi 583 fi
475 if [[ ${euid} == "next" ]] ; then 584 if [[ ${euid} == "next" ]] ; then
476 for euid in $(seq 101 999) ; do 585 for ((euid = 101; euid <= 999; euid++)); do
477 [[ -z $(egetent passwd ${euid}) ]] && break 586 [[ -z $(egetent passwd ${euid}) ]] && break
478 done 587 done
479 fi 588 fi
480 opts="${opts} -u ${euid}" 589 opts="${opts} -u ${euid}"
481 einfo " - Userid: ${euid}" 590 einfo " - Userid: ${euid}"
495 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do 604 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
496 [[ -x ${ROOT}${shell} ]] && break 605 [[ -x ${ROOT}${shell} ]] && break
497 done 606 done
498 607
499 if [[ ${shell} == "/dev/null" ]] ; then 608 if [[ ${shell} == "/dev/null" ]] ; then
500 eerror "Unable to identify the shell to use" 609 eerror "Unable to identify the shell to use, proceeding with userland default."
501 die "Unable to identify the shell to use" 610 case ${USERLAND} in
611 GNU) shell="/bin/false" ;;
612 BSD) shell="/sbin/nologin" ;;
613 Darwin) shell="/usr/sbin/nologin" ;;
614 *) die "Unable to identify the default shell for userland ${USERLAND}"
615 esac
502 fi 616 fi
503 617
504 eshell=${shell} 618 eshell=${shell}
505 fi 619 fi
506 einfo " - Shell: ${eshell}" 620 einfo " - Shell: ${eshell}"
604 fi 718 fi
605 ;; 719 ;;
606 720
607 *) 721 *)
608 if [[ -z $@ ]] ; then 722 if [[ -z $@ ]] ; then
609 useradd ${opts} ${euser} \ 723 useradd -r ${opts} \
610 -c "added by portage for ${PN}" \ 724 -c "added by portage for ${PN}" \
725 ${euser} \
611 || die "enewuser failed" 726 || die "enewuser failed"
612 else 727 else
613 einfo " - Extra: $@" 728 einfo " - Extra: $@"
614 useradd ${opts} ${euser} "$@" \ 729 useradd -r ${opts} "$@" \
730 ${euser} \
615 || die "enewuser failed" 731 || die "enewuser failed"
616 fi 732 fi
617 ;; 733 ;;
618 esac 734 esac
619 735
625 fi 741 fi
626 742
627 export SANDBOX_ON=${oldsandbox} 743 export SANDBOX_ON=${oldsandbox}
628} 744}
629 745
630# Simplify/standardize adding groups to the system 746# @FUNCTION: enewgroup
631# vapier@gentoo.org 747# @USAGE: <group> [gid]
632# 748# @DESCRIPTION:
633# enewgroup(group, gid) 749# This function does not require you to understand how to properly add a
634# 750# group to the system. Just give it a group name to add and enewgroup will
635# Default values if you do not specify any: 751# do the rest. You may specify the gid for the group or allow the group to
636# groupname: REQUIRED ! 752# allocate the next available one.
637# gid: next available (see groupadd(8))
638# extra: none
639enewgroup() { 753enewgroup() {
640 case ${EBUILD_PHASE} in 754 case ${EBUILD_PHASE} in
641 unpack|compile|test|install) 755 unpack|compile|test|install)
642 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 756 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
643 eerror "Package fails at QA and at life. Please file a bug." 757 eerror "Package fails at QA and at life. Please file a bug."
651 eerror "No group specified !" 765 eerror "No group specified !"
652 die "Cannot call enewgroup without a group" 766 die "Cannot call enewgroup without a group"
653 fi 767 fi
654 768
655 # see if group already exists 769 # see if group already exists
656 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ] 770 if [[ -n $(egetent group "${egroup}") ]]; then
657 then
658 return 0 771 return 0
659 fi 772 fi
660 einfo "Adding group '${egroup}' to your system ..." 773 einfo "Adding group '${egroup}' to your system ..."
661 774
662 # options to pass to useradd 775 # options to pass to useradd
705 fi 818 fi
706 819
707 # If we need the next available 820 # If we need the next available
708 case ${egid} in 821 case ${egid} in
709 *[!0-9]*) # Non numeric 822 *[!0-9]*) # Non numeric
710 for egid in $(seq 101 999); do 823 for ((egid = 101; egid <= 999; egid++)); do
711 [ -z "`egetent group ${egid}`" ] && break 824 [[ -z $(egetent group ${egid}) ]] && break
712 done 825 done
713 esac 826 esac
714 dscl . create /groups/${egroup} gid ${egid} 827 dscl . create /groups/${egroup} gid ${egid}
715 dscl . create /groups/${egroup} passwd '*' 828 dscl . create /groups/${egroup} passwd '*'
716 ;; 829 ;;
717 830
718 *-freebsd*|*-dragonfly*) 831 *-freebsd*|*-dragonfly*)
719 case ${egid} in 832 case ${egid} in
720 *[!0-9]*) # Non numeric 833 *[!0-9]*) # Non numeric
721 for egid in $(seq 101 999); do 834 for ((egid = 101; egid <= 999; egid++)); do
722 [ -z "`egetent group ${egid}`" ] && break 835 [[ -z $(egetent group ${egid}) ]] && break
723 done 836 done
724 esac 837 esac
725 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 838 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
726 ;; 839 ;;
727 840
728 *-netbsd*) 841 *-netbsd*)
729 case ${egid} in 842 case ${egid} in
730 *[!0-9]*) # Non numeric 843 *[!0-9]*) # Non numeric
731 for egid in $(seq 101 999); do 844 for ((egid = 101; egid <= 999; egid++)); do
732 [ -z "`egetent group ${egid}`" ] && break 845 [[ -z $(egetent group ${egid}) ]] && break
733 done 846 done
734 esac 847 esac
735 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 848 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
736 ;; 849 ;;
737 850
738 *) 851 *)
852 # We specify -r so that we get a GID in the system range from login.defs
739 groupadd ${opts} ${egroup} || die "enewgroup failed" 853 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
740 ;; 854 ;;
741 esac 855 esac
742 export SANDBOX_ON="${oldsandbox}" 856 export SANDBOX_ON="${oldsandbox}"
743} 857}
744 858
745# Simple script to replace 'dos2unix' binaries 859# @FUNCTION: edos2unix
746# vapier@gentoo.org 860# @USAGE: <file> [more files ...]
747# 861# @DESCRIPTION:
748# edos2unix(file, <more files> ...) 862# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
863# to remove all of these text utilities from DEPEND variables because this
864# is a script based solution. Just give it a list of files to convert and
865# they will all be changed from the DOS CRLF format to the UNIX LF format.
749edos2unix() { 866edos2unix() {
750 for f in "$@" 867 echo "$@" | xargs sed -i 's/\r$//'
751 do
752 cp "${f}" ${T}/edos2unix
753 sed 's/\r$//' ${T}/edos2unix > "${f}"
754 done
755} 868}
756
757
758##############################################################
759# START: Handle .desktop files and menu entries #
760# maybe this should be separated into a new eclass some time #
761# lanius@gentoo.org #
762##############################################################
763 869
764# Make a desktop file ! 870# Make a desktop file !
765# Great for making those icons in kde/gnome startmenu ! 871# Great for making those icons in kde/gnome startmenu !
766# Amaze your friends ! Get the women ! Join today ! 872# Amaze your friends ! Get the women ! Join today !
767# 873#
768# make_desktop_entry(<command>, [name], [icon], [type], [path]) 874# make_desktop_entry(<command>, [name], [icon], [type], [fields])
769# 875#
770# binary: what command does the app run with ? 876# binary: what command does the app run with ?
771# name: the name that will show up in the menu 877# name: the name that will show up in the menu
772# icon: give your little like a pretty little icon ... 878# icon: give your little like a pretty little icon ...
773# this can be relative (to /usr/share/pixmaps) or 879# this can be relative (to /usr/share/pixmaps) or
774# a full path to an icon 880# a full path to an icon
775# type: what kind of application is this ? for categories: 881# type: what kind of application is this ? for categories:
776# http://www.freedesktop.org/Standards/desktop-entry-spec 882# http://standards.freedesktop.org/menu-spec/latest/apa.html
777# path: if your app needs to startup in a specific dir 883# fields: extra fields to append to the desktop file; a printf string
778make_desktop_entry() { 884make_desktop_entry() {
779 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 885 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
780 886
781 local exec=${1} 887 local exec=${1}
782 local name=${2:-${PN}} 888 local name=${2:-${PN}}
783 local icon=${3:-${PN}.png} 889 local icon=${3:-${PN}}
784 local type=${4} 890 local type=${4}
785 local path=${5} 891 local fields=${5}
786 892
787 if [[ -z ${type} ]] ; then 893 if [[ -z ${type} ]] ; then
788 local catmaj=${CATEGORY%%-*} 894 local catmaj=${CATEGORY%%-*}
789 local catmin=${CATEGORY##*-} 895 local catmin=${CATEGORY##*-}
790 case ${catmaj} in 896 case ${catmaj} in
791 app) 897 app)
792 case ${catmin} in 898 case ${catmin} in
899 accessibility) type=Accessibility;;
793 admin) type=System;; 900 admin) type=System;;
901 antivirus) type=System;;
902 arch) type=Archiving;;
903 backup) type=Archiving;;
794 cdr) type=DiscBurning;; 904 cdr) type=DiscBurning;;
795 dicts) type=Dictionary;; 905 dicts) type=Dictionary;;
906 doc) type=Documentation;;
796 editors) type=TextEditor;; 907 editors) type=TextEditor;;
797 emacs) type=TextEditor;; 908 emacs) type=TextEditor;;
798 emulation) type=Emulator;; 909 emulation) type=Emulator;;
799 laptop) type=HardwareSettings;; 910 laptop) type=HardwareSettings;;
800 office) type=Office;; 911 office) type=Office;;
912 pda) type=PDA;;
801 vim) type=TextEditor;; 913 vim) type=TextEditor;;
802 xemacs) type=TextEditor;; 914 xemacs) type=TextEditor;;
803 *) type=;;
804 esac 915 esac
805 ;; 916 ;;
806 917
807 dev) 918 dev)
808 type="Development" 919 type="Development"
809 ;; 920 ;;
810 921
811 games) 922 games)
812 case ${catmin} in 923 case ${catmin} in
813 action) type=ActionGame;; 924 action|fps) type=ActionGame;;
814 arcade) type=ArcadeGame;; 925 arcade) type=ArcadeGame;;
815 board) type=BoardGame;; 926 board) type=BoardGame;;
816 kid) type=KidsGame;;
817 emulation) type=Emulator;; 927 emulation) type=Emulator;;
928 kids) type=KidsGame;;
818 puzzle) type=LogicGame;; 929 puzzle) type=LogicGame;;
930 roguelike) type=RolePlaying;;
819 rpg) type=RolePlaying;; 931 rpg) type=RolePlaying;;
820 roguelike) type=RolePlaying;;
821 simulation) type=Simulation;; 932 simulation) type=Simulation;;
822 sports) type=SportsGame;; 933 sports) type=SportsGame;;
823 strategy) type=StrategyGame;; 934 strategy) type=StrategyGame;;
824 *) type=;;
825 esac 935 esac
826 type="Game;${type}" 936 type="Game;${type}"
827 ;; 937 ;;
828 938
939 gnome)
940 type="Gnome;GTK"
941 ;;
942
943 kde)
944 type="KDE;Qt"
945 ;;
946
829 mail) 947 mail)
830 type="Network;Email" 948 type="Network;Email"
831 ;; 949 ;;
832 950
833 media) 951 media)
834 case ${catmin} in 952 case ${catmin} in
953 gfx)
835 gfx) type=Graphics;; 954 type=Graphics
955 ;;
956 *)
957 case ${catmin} in
836 radio) type=Tuner;; 958 radio) type=Tuner;;
837 sound) type=Audio;; 959 sound) type=Audio;;
838 tv) type=TV;; 960 tv) type=TV;;
839 video) type=Video;; 961 video) type=Video;;
840 *) type=;; 962 esac
963 type="AudioVideo;${type}"
964 ;;
841 esac 965 esac
842 type="AudioVideo;${type}"
843 ;; 966 ;;
844 967
845 net) 968 net)
846 case ${catmin} in 969 case ${catmin} in
847 dialup) type=Dialup;; 970 dialup) type=Dialup;;
850 irc) type=IRCClient;; 973 irc) type=IRCClient;;
851 mail) type=Email;; 974 mail) type=Email;;
852 news) type=News;; 975 news) type=News;;
853 nntp) type=News;; 976 nntp) type=News;;
854 p2p) type=FileTransfer;; 977 p2p) type=FileTransfer;;
855 *) type=;; 978 voip) type=Telephony;;
856 esac 979 esac
857 type="Network;${type}" 980 type="Network;${type}"
858 ;; 981 ;;
859 982
860 sci) 983 sci)
861 case ${catmin} in 984 case ${catmin} in
862 astro*) type=Astronomy;; 985 astro*) type=Astronomy;;
863 bio*) type=Biology;; 986 bio*) type=Biology;;
864 calc*) type=Calculator;; 987 calc*) type=Calculator;;
865 chem*) type=Chemistry;; 988 chem*) type=Chemistry;;
989 elec*) type=Electronics;;
866 geo*) type=Geology;; 990 geo*) type=Geology;;
867 math*) type=Math;; 991 math*) type=Math;;
868 *) type=;; 992 physics) type=Physics;;
993 visual*) type=DataVisualization;;
869 esac 994 esac
870 type="Science;${type}" 995 type="Education;Science;${type}"
996 ;;
997
998 sys)
999 type="System"
871 ;; 1000 ;;
872 1001
873 www) 1002 www)
874 case ${catmin} in 1003 case ${catmin} in
875 client) type=WebBrowser;; 1004 client) type=WebBrowser;;
876 *) type=;;
877 esac 1005 esac
878 type="Network" 1006 type="Network;${type}"
879 ;; 1007 ;;
880 1008
881 *) 1009 *)
882 type= 1010 type=
883 ;; 1011 ;;
886 if [ "${SLOT}" == "0" ] ; then 1014 if [ "${SLOT}" == "0" ] ; then
887 local desktop_name="${PN}" 1015 local desktop_name="${PN}"
888 else 1016 else
889 local desktop_name="${PN}-${SLOT}" 1017 local desktop_name="${PN}-${SLOT}"
890 fi 1018 fi
891 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 1019 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
892# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1020 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
893 1021
1022 # Don't append another ";" when a valid category value is provided.
1023 type=${type%;}${type:+;}
1024
1025 eshopts_push -s extglob
1026 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1027 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1028 ewarn "allowed in .desktop files if the value is not an absolute path."
1029 icon=${icon%.@(xpm|png|svg)}
1030 fi
1031 eshopts_pop
1032
1033 cat <<-EOF > "${desktop}"
894echo "[Desktop Entry] 1034 [Desktop Entry]
895Encoding=UTF-8
896Version=0.9.2
897Name=${name} 1035 Name=${name}
898Type=Application 1036 Type=Application
899Comment=${DESCRIPTION} 1037 Comment=${DESCRIPTION}
900Exec=${exec} 1038 Exec=${exec}
901TryExec=${exec%% *} 1039 TryExec=${exec%% *}
902Path=${path}
903Icon=${icon} 1040 Icon=${icon}
904Categories=Application;${type};" > "${desktop}" 1041 Categories=${type}
1042 EOF
1043
1044 if [[ ${fields:-=} != *=* ]] ; then
1045 # 5th arg used to be value to Path=
1046 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1047 fields="Path=${fields}"
1048 fi
1049 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
905 1050
906 ( 1051 (
907 # wrap the env here so that the 'insinto' call 1052 # wrap the env here so that the 'insinto' call
908 # doesn't corrupt the env of the caller 1053 # doesn't corrupt the env of the caller
909 insinto /usr/share/applications 1054 insinto /usr/share/applications
910 doins "${desktop}" 1055 doins "${desktop}"
911 ) 1056 ) || die "installing desktop file failed"
912} 1057}
913 1058
914# Make a GDM/KDM Session file 1059# @FUNCTION: validate_desktop_entries
915# 1060# @USAGE: [directories]
916# make_desktop_entry(<title>, <command>) 1061# @MAINTAINER:
917# title: File to execute to start the Window Manager 1062# Carsten Lohrke <carlo@gentoo.org>
918# command: Name of the Window Manager 1063# @DESCRIPTION:
1064# Validate desktop entries using desktop-file-utils
1065validate_desktop_entries() {
1066 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1067 einfo "Checking desktop entry validity"
1068 local directories=""
1069 for d in /usr/share/applications $@ ; do
1070 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1071 done
1072 if [[ -n ${directories} ]] ; then
1073 for FILE in $(find ${directories} -name "*\.desktop" \
1074 -not -path '*.hidden*' | sort -u 2>/dev/null)
1075 do
1076 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1077 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1078 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1079 done
1080 fi
1081 echo ""
1082 else
1083 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1084 fi
1085}
919 1086
1087# @FUNCTION: make_session_desktop
1088# @USAGE: <title> <command> [command args...]
1089# @DESCRIPTION:
1090# Make a GDM/KDM Session file. The title is the file to execute to start the
1091# Window Manager. The command is the name of the Window Manager.
1092#
1093# You can set the name of the file via the ${wm} variable.
920make_session_desktop() { 1094make_session_desktop() {
921 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1095 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
922 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1096 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
923 1097
924 local title=$1 1098 local title=$1
925 local command=$2 1099 local command=$2
926 local desktop=${T}/${wm}.desktop 1100 local desktop=${T}/${wm:-${PN}}.desktop
1101 shift 2
927 1102
1103 cat <<-EOF > "${desktop}"
928echo "[Desktop Entry] 1104 [Desktop Entry]
929Encoding=UTF-8
930Name=${title} 1105 Name=${title}
931Comment=This session logs you into ${title} 1106 Comment=This session logs you into ${title}
932Exec=${command} 1107 Exec=${command} $*
933TryExec=${command} 1108 TryExec=${command}
934Type=Application" > "${desktop}" 1109 Type=XSession
1110 EOF
935 1111
1112 (
1113 # wrap the env here so that the 'insinto' call
1114 # doesn't corrupt the env of the caller
936 insinto /usr/share/xsessions 1115 insinto /usr/share/xsessions
937 doins "${desktop}" 1116 doins "${desktop}"
1117 )
938} 1118}
939 1119
1120# @FUNCTION: domenu
1121# @USAGE: <menus>
1122# @DESCRIPTION:
1123# Install the list of .desktop menu files into the appropriate directory
1124# (/usr/share/applications).
940domenu() { 1125domenu() {
1126 (
1127 # wrap the env here so that the 'insinto' call
1128 # doesn't corrupt the env of the caller
941 local i j 1129 local i j ret=0
942 insinto /usr/share/applications 1130 insinto /usr/share/applications
943 for i in "$@" ; do 1131 for i in "$@" ; do
944 if [[ -f ${i} ]] ; then 1132 if [[ -f ${i} ]] ; then
945 doins "${i}" 1133 doins "${i}"
1134 ((ret+=$?))
946 elif [[ -d ${i} ]] ; then 1135 elif [[ -d ${i} ]] ; then
947 for j in "${i}"/*.desktop ; do 1136 for j in "${i}"/*.desktop ; do
948 doins "${j}" 1137 doins "${j}"
1138 ((ret+=$?))
949 done 1139 done
1140 else
1141 ((++ret))
950 fi 1142 fi
951 done 1143 done
1144 exit ${ret}
1145 )
952} 1146}
1147
1148# @FUNCTION: newmenu
1149# @USAGE: <menu> <newname>
1150# @DESCRIPTION:
1151# Like all other new* functions, install the specified menu as newname.
953newmenu() { 1152newmenu() {
1153 (
1154 # wrap the env here so that the 'insinto' call
1155 # doesn't corrupt the env of the caller
954 insinto /usr/share/applications 1156 insinto /usr/share/applications
955 newins "$1" "$2" 1157 newins "$@"
1158 )
956} 1159}
957 1160
1161# @FUNCTION: doicon
1162# @USAGE: <list of icons>
1163# @DESCRIPTION:
1164# Install the list of icons into the icon directory (/usr/share/pixmaps).
1165# This is useful in conjunction with creating desktop/menu files.
958doicon() { 1166doicon() {
1167 (
1168 # wrap the env here so that the 'insinto' call
1169 # doesn't corrupt the env of the caller
959 local i j 1170 local i j ret
960 insinto /usr/share/pixmaps 1171 insinto /usr/share/pixmaps
961 for i in "$@" ; do 1172 for i in "$@" ; do
962 if [[ -f ${i} ]] ; then 1173 if [[ -f ${i} ]] ; then
963 doins "${i}" 1174 doins "${i}"
1175 ((ret+=$?))
964 elif [[ -d ${i} ]] ; then 1176 elif [[ -d ${i} ]] ; then
965 for j in "${i}"/*.png ; do 1177 for j in "${i}"/*.png ; do
966 doins "${j}" 1178 doins "${j}"
1179 ((ret+=$?))
967 done 1180 done
1181 else
1182 ((++ret))
968 fi 1183 fi
969 done 1184 done
1185 exit ${ret}
1186 )
970} 1187}
1188
1189# @FUNCTION: newicon
1190# @USAGE: <icon> <newname>
1191# @DESCRIPTION:
1192# Like all other new* functions, install the specified icon as newname.
971newicon() { 1193newicon() {
1194 (
1195 # wrap the env here so that the 'insinto' call
1196 # doesn't corrupt the env of the caller
972 insinto /usr/share/pixmaps 1197 insinto /usr/share/pixmaps
973 newins "$1" "$2" 1198 newins "$@"
1199 )
974} 1200}
975
976##############################################################
977# END: Handle .desktop files and menu entries #
978##############################################################
979
980 1201
981# for internal use only (unpack_pdv and unpack_makeself) 1202# for internal use only (unpack_pdv and unpack_makeself)
982find_unpackable_file() { 1203find_unpackable_file() {
983 local src=$1 1204 local src=$1
984 if [[ -z ${src} ]] ; then 1205 if [[ -z ${src} ]] ; then
994 fi 1215 fi
995 [[ ! -e ${src} ]] && return 1 1216 [[ ! -e ${src} ]] && return 1
996 echo "${src}" 1217 echo "${src}"
997} 1218}
998 1219
1220# @FUNCTION: unpack_pdv
1221# @USAGE: <file to unpack> <size of off_t>
1222# @DESCRIPTION:
999# Unpack those pesky pdv generated files ... 1223# Unpack those pesky pdv generated files ...
1000# They're self-unpacking programs with the binary package stuffed in 1224# They're self-unpacking programs with the binary package stuffed in
1001# the middle of the archive. Valve seems to use it a lot ... too bad 1225# the middle of the archive. Valve seems to use it a lot ... too bad
1002# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1226# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1003# 1227#
1004# Usage: unpack_pdv [file to unpack] [size of off_t]
1005# - you have to specify the off_t size ... i have no idea how to extract that 1228# You have to specify the off_t size ... I have no idea how to extract that
1006# information out of the binary executable myself. basically you pass in 1229# information out of the binary executable myself. Basically you pass in
1007# the size of the off_t type (in bytes) on the machine that built the pdv 1230# the size of the off_t type (in bytes) on the machine that built the pdv
1231# archive.
1232#
1008# archive. one way to determine this is by running the following commands: 1233# One way to determine this is by running the following commands:
1234#
1235# @CODE
1009# strings <pdv archive> | grep lseek 1236# strings <pdv archive> | grep lseek
1010# strace -elseek <pdv archive> 1237# strace -elseek <pdv archive>
1238# @CODE
1239#
1011# basically look for the first lseek command (we do the strings/grep because 1240# Basically look for the first lseek command (we do the strings/grep because
1012# sometimes the function call is _llseek or something) and steal the 2nd 1241# sometimes the function call is _llseek or something) and steal the 2nd
1013# parameter. here is an example: 1242# parameter. Here is an example:
1243#
1244# @CODE
1014# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 1245# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1015# lseek 1246# lseek
1016# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1247# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1017# lseek(3, -4, SEEK_END) = 2981250 1248# lseek(3, -4, SEEK_END) = 2981250
1249# @CODE
1250#
1018# thus we would pass in the value of '4' as the second parameter. 1251# Thus we would pass in the value of '4' as the second parameter.
1019unpack_pdv() { 1252unpack_pdv() {
1020 local src=$(find_unpackable_file $1) 1253 local src=$(find_unpackable_file "$1")
1021 local sizeoff_t=$2 1254 local sizeoff_t=$2
1022 1255
1023 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1256 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1024 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1257 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1025 1258
1026 local shrtsrc=$(basename "${src}") 1259 local shrtsrc=$(basename "${src}")
1027 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1260 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1028 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1261 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1029 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1262 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1030 1263
1031 # grab metadata for debug reasons 1264 # grab metadata for debug reasons
1032 local metafile="$(emktemp)" 1265 local metafile=$(emktemp)
1033 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 1266 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1034 1267
1035 # rip out the final file name from the metadata 1268 # rip out the final file name from the metadata
1036 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 1269 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1037 datafile="`basename ${datafile}`" 1270 datafile=$(basename "${datafile}")
1038 1271
1039 # now lets uncompress/untar the file if need be 1272 # now lets uncompress/untar the file if need be
1040 local tmpfile="$(emktemp)" 1273 local tmpfile=$(emktemp)
1041 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1274 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1042 1275
1043 local iscompressed="`file -b ${tmpfile}`" 1276 local iscompressed=$(file -b "${tmpfile}")
1044 if [ "${iscompressed:0:8}" == "compress" ] ; then 1277 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1045 iscompressed=1 1278 iscompressed=1
1046 mv ${tmpfile}{,.Z} 1279 mv ${tmpfile}{,.Z}
1047 gunzip ${tmpfile} 1280 gunzip ${tmpfile}
1048 else 1281 else
1049 iscompressed=0 1282 iscompressed=0
1050 fi 1283 fi
1051 local istar="`file -b ${tmpfile}`" 1284 local istar=$(file -b "${tmpfile}")
1052 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1285 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1053 istar=1 1286 istar=1
1054 else 1287 else
1055 istar=0 1288 istar=0
1056 fi 1289 fi
1057 1290
1085 true 1318 true
1086 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1319 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1087 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1320 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1088} 1321}
1089 1322
1323# @FUNCTION: unpack_makeself
1324# @USAGE: [file to unpack] [offset] [tail|dd]
1325# @DESCRIPTION:
1090# Unpack those pesky makeself generated files ... 1326# Unpack those pesky makeself generated files ...
1091# They're shell scripts with the binary package tagged onto 1327# They're shell scripts with the binary package tagged onto
1092# the end of the archive. Loki utilized the format as does 1328# the end of the archive. Loki utilized the format as does
1093# many other game companies. 1329# many other game companies.
1094# 1330#
1095# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1331# If the file is not specified, then ${A} is used. If the
1096# - If the file is not specified then unpack will utilize ${A}.
1097# - If the offset is not specified then we will attempt to extract 1332# offset is not specified then we will attempt to extract
1098# the proper offset from the script itself. 1333# the proper offset from the script itself.
1099unpack_makeself() { 1334unpack_makeself() {
1100 local src_input=${1:-${A}} 1335 local src_input=${1:-${A}}
1101 local src=$(find_unpackable_file "${src_input}") 1336 local src=$(find_unpackable_file "${src_input}")
1102 local skip=$2 1337 local skip=$2
1103 local exe=$3 1338 local exe=$3
1105 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1340 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1106 1341
1107 local shrtsrc=$(basename "${src}") 1342 local shrtsrc=$(basename "${src}")
1108 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1343 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1109 if [[ -z ${skip} ]] ; then 1344 if [[ -z ${skip} ]] ; then
1110 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1345 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1111 local skip=0 1346 local skip=0
1112 exe=tail 1347 exe=tail
1113 case ${ver} in 1348 case ${ver} in
1114 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1349 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1115 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1350 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1117 2.0|2.0.1) 1352 2.0|2.0.1)
1118 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1353 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1119 ;; 1354 ;;
1120 2.1.1) 1355 2.1.1)
1121 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1356 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1122 let skip="skip + 1" 1357 (( skip++ ))
1123 ;; 1358 ;;
1124 2.1.2) 1359 2.1.2)
1125 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1360 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1126 let skip="skip + 1" 1361 (( skip++ ))
1127 ;; 1362 ;;
1128 2.1.3) 1363 2.1.3)
1129 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1364 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1130 let skip="skip + 1" 1365 (( skip++ ))
1131 ;; 1366 ;;
1132 2.1.4|2.1.5) 1367 2.1.4|2.1.5)
1133 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1368 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1134 skip=$(head -n ${skip} "${src}" | wc -c) 1369 skip=$(head -n ${skip} "${src}" | wc -c)
1135 exe="dd" 1370 exe="dd"
1144 esac 1379 esac
1145 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1380 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1146 fi 1381 fi
1147 case ${exe} in 1382 case ${exe} in
1148 tail) exe="tail -n +${skip} '${src}'";; 1383 tail) exe="tail -n +${skip} '${src}'";;
1149 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1384 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1150 *) die "makeself cant handle exe '${exe}'" 1385 *) die "makeself cant handle exe '${exe}'"
1151 esac 1386 esac
1152 1387
1153 # lets grab the first few bytes of the file to figure out what kind of archive it is 1388 # lets grab the first few bytes of the file to figure out what kind of archive it is
1154 local tmpfile="$(emktemp)" 1389 local tmpfile=$(emktemp)
1155 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1390 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1156 local filetype="$(file -b "${tmpfile}")" 1391 local filetype=$(file -b "${tmpfile}")
1157 case ${filetype} in 1392 case ${filetype} in
1158 *tar\ archive) 1393 *tar\ archive*)
1159 eval ${exe} | tar --no-same-owner -xf - 1394 eval ${exe} | tar --no-same-owner -xf -
1160 ;; 1395 ;;
1161 bzip2*) 1396 bzip2*)
1162 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1397 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1163 ;; 1398 ;;
1173 ;; 1408 ;;
1174 esac 1409 esac
1175 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1410 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1176} 1411}
1177 1412
1413# @FUNCTION: check_license
1414# @USAGE: [license]
1415# @DESCRIPTION:
1178# Display a license for user to accept. 1416# Display a license for user to accept. If no license is
1179#
1180# Usage: check_license [license]
1181# - If the file is not specified then ${LICENSE} is used. 1417# specified, then ${LICENSE} is used.
1182check_license() { 1418check_license() {
1183 local lic=$1 1419 local lic=$1
1184 if [ -z "${lic}" ] ; then 1420 if [ -z "${lic}" ] ; then
1185 lic="${PORTDIR}/licenses/${LICENSE}" 1421 lic="${PORTDIR}/licenses/${LICENSE}"
1186 else 1422 else
1190 lic="${PWD}/${lic}" 1426 lic="${PWD}/${lic}"
1191 elif [ -e "${lic}" ] ; then 1427 elif [ -e "${lic}" ] ; then
1192 lic="${lic}" 1428 lic="${lic}"
1193 fi 1429 fi
1194 fi 1430 fi
1195 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1196 local l="`basename ${lic}`" 1431 local l="`basename ${lic}`"
1197 1432
1198 # here is where we check for the licenses the user already 1433 # here is where we check for the licenses the user already
1199 # accepted ... if we don't find a match, we make the user accept 1434 # accepted ... if we don't find a match, we make the user accept
1200 local shopts=$-
1201 local alic 1435 local alic
1202 set -o noglob #so that bash doesn't expand "*" 1436 eshopts_push -o noglob # so that bash doesn't expand "*"
1203 for alic in ${ACCEPT_LICENSE} ; do 1437 for alic in ${ACCEPT_LICENSE} ; do
1204 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1438 if [[ ${alic} == ${l} ]]; then
1205 set +o noglob; set -${shopts} #reset old shell opts 1439 eshopts_pop
1206 return 0 1440 return 0
1207 fi 1441 fi
1208 done 1442 done
1209 set +o noglob; set -$shopts #reset old shell opts 1443 eshopts_pop
1444 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1210 1445
1211 local licmsg="$(emktemp)" 1446 local licmsg=$(emktemp)
1212 cat << EOF > ${licmsg} 1447 cat <<-EOF > ${licmsg}
1213********************************************************** 1448 **********************************************************
1214The following license outlines the terms of use of this 1449 The following license outlines the terms of use of this
1215package. You MUST accept this license for installation to 1450 package. You MUST accept this license for installation to
1216continue. When you are done viewing, hit 'q'. If you 1451 continue. When you are done viewing, hit 'q'. If you
1217CTRL+C out of this, the install will not run! 1452 CTRL+C out of this, the install will not run!
1218********************************************************** 1453 **********************************************************
1219 1454
1220EOF 1455 EOF
1221 cat ${lic} >> ${licmsg} 1456 cat ${lic} >> ${licmsg}
1222 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1457 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1223 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1458 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1224 read alic 1459 read alic
1225 case ${alic} in 1460 case ${alic} in
1232 die "Failed to accept license" 1467 die "Failed to accept license"
1233 ;; 1468 ;;
1234 esac 1469 esac
1235} 1470}
1236 1471
1472# @FUNCTION: cdrom_get_cds
1473# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1474# @DESCRIPTION:
1237# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1475# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1238# the whole 'non-interactive' policy, but damnit I want CD support ! 1476# the whole 'non-interactive' policy, but damnit I want CD support !
1239# 1477#
1240# with these cdrom functions we handle all the user interaction and 1478# With these cdrom functions we handle all the user interaction and
1241# standardize everything. all you have to do is call cdrom_get_cds() 1479# standardize everything. All you have to do is call cdrom_get_cds()
1242# and when the function returns, you can assume that the cd has been 1480# and when the function returns, you can assume that the cd has been
1243# found at CDROM_ROOT. 1481# found at CDROM_ROOT.
1244# 1482#
1483# The function will attempt to locate a cd based upon a file that is on
1484# the cd. The more files you give this function, the more cds
1485# the cdrom functions will handle.
1486#
1245# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1487# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1246# etc... if you want to give the cds better names, then just export 1488# etc... If you want to give the cds better names, then just export
1247# the appropriate CDROM_NAME variable before calling cdrom_get_cds(). 1489# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1248# - CDROM_NAME="fooie cd" - for when you only want 1 cd 1490# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1249# - CDROM_NAME_1="install cd" - for when you want more than 1 cd 1491# also use the CDROM_NAME_SET bash array.
1250# CDROM_NAME_2="data cd"
1251# - CDROM_NAME_SET=( "install cd" "data cd" ) - short hand for CDROM_NAME_#
1252# 1492#
1253# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1493# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1254#
1255# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1256# - this will attempt to locate a cd based upon a file that is on
1257# the cd ... the more files you give this function, the more cds
1258# the cdrom functions will handle
1259cdrom_get_cds() { 1494cdrom_get_cds() {
1260 # first we figure out how many cds we're dealing with by 1495 # first we figure out how many cds we're dealing with by
1261 # the # of files they gave us 1496 # the # of files they gave us
1262 local cdcnt=0 1497 local cdcnt=0
1263 local f= 1498 local f=
1287 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1522 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1288 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1523 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1289 export CDROM_SET=-1 1524 export CDROM_SET=-1
1290 for f in ${CDROM_CHECK_1//:/ } ; do 1525 for f in ${CDROM_CHECK_1//:/ } ; do
1291 ((++CDROM_SET)) 1526 ((++CDROM_SET))
1292 [[ -e ${CD_ROOT}/${f} ]] && break 1527 [[ -e ${CDROM_ROOT}/${f} ]] && break
1293 done 1528 done
1294 export CDROM_MATCH=${f} 1529 export CDROM_MATCH=${f}
1295 return 1530 return
1296 fi 1531 fi
1297 1532
1349 export CDROM_SET="" 1584 export CDROM_SET=""
1350 export CDROM_CURRENT_CD=0 1585 export CDROM_CURRENT_CD=0
1351 cdrom_load_next_cd 1586 cdrom_load_next_cd
1352} 1587}
1353 1588
1354# this is only used when you need access to more than one cd. 1589# @FUNCTION: cdrom_load_next_cd
1355# when you have finished using the first cd, just call this function. 1590# @DESCRIPTION:
1356# when it returns, CDROM_ROOT will be pointing to the second cd. 1591# Some packages are so big they come on multiple CDs. When you're done reading
1357# remember, you can only go forward in the cd chain, you can't go back. 1592# files off a CD and want access to the next one, just call this function.
1593# Again, all the messy details of user interaction are taken care of for you.
1594# Once this returns, just read the variable CDROM_ROOT for the location of the
1595# mounted CD. Note that you can only go forward in the CD list, so make sure
1596# you only call this function when you're done using the current CD.
1358cdrom_load_next_cd() { 1597cdrom_load_next_cd() {
1359 local var 1598 local var
1360 ((++CDROM_CURRENT_CD)) 1599 ((++CDROM_CURRENT_CD))
1361 1600
1362 unset CDROM_ROOT 1601 unset CDROM_ROOT
1379# displayed and we'll hang out here until: 1618# displayed and we'll hang out here until:
1380# (1) the file is found on a mounted cdrom 1619# (1) the file is found on a mounted cdrom
1381# (2) the user hits CTRL+C 1620# (2) the user hits CTRL+C
1382_cdrom_locate_file_on_cd() { 1621_cdrom_locate_file_on_cd() {
1383 local mline="" 1622 local mline=""
1384 local showedmsg=0 1623 local showedmsg=0 showjolietmsg=0
1385 1624
1386 while [[ -z ${CDROM_ROOT} ]] ; do 1625 while [[ -z ${CDROM_ROOT} ]] ; do
1387 local i=0 1626 local i=0
1388 local -a cdset=(${*//:/ }) 1627 local -a cdset=(${*//:/ })
1389 if [[ -n ${CDROM_SET} ]] ; then 1628 if [[ -n ${CDROM_SET} ]] ; then
1392 1631
1393 while [[ -n ${cdset[${i}]} ]] ; do 1632 while [[ -n ${cdset[${i}]} ]] ; do
1394 local dir=$(dirname ${cdset[${i}]}) 1633 local dir=$(dirname ${cdset[${i}]})
1395 local file=$(basename ${cdset[${i}]}) 1634 local file=$(basename ${cdset[${i}]})
1396 1635
1397 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1636 local point= node= fs= foo=
1637 while read point node fs foo ; do
1638 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1639 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1640 && continue
1641 point=${point//\040/ }
1398 [[ -d ${mline}/${dir} ]] || continue 1642 [[ ! -d ${point}/${dir} ]] && continue
1399 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1643 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1400 export CDROM_ROOT=${mline} 1644 export CDROM_ROOT=${point}
1401 export CDROM_SET=${i} 1645 export CDROM_SET=${i}
1402 export CDROM_MATCH=${cdset[${i}]} 1646 export CDROM_MATCH=${cdset[${i}]}
1403 return 1647 return
1404 fi 1648 done <<< "$(get_mounts)"
1405 done
1406 1649
1407 ((++i)) 1650 ((++i))
1408 done 1651 done
1409 1652
1410 echo 1653 echo
1426 showedmsg=1 1669 showedmsg=1
1427 fi 1670 fi
1428 einfo "Press return to scan for the cd again" 1671 einfo "Press return to scan for the cd again"
1429 einfo "or hit CTRL+C to abort the emerge." 1672 einfo "or hit CTRL+C to abort the emerge."
1430 echo 1673 echo
1674 if [[ ${showjolietmsg} -eq 0 ]] ; then
1675 showjolietmsg=1
1676 else
1431 einfo "If you are having trouble with the detection" 1677 ewarn "If you are having trouble with the detection"
1432 einfo "of your CD, it is possible that you do not have" 1678 ewarn "of your CD, it is possible that you do not have"
1433 einfo "Joliet support enabled in your kernel. Please" 1679 ewarn "Joliet support enabled in your kernel. Please"
1434 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1680 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1681 ebeep 5
1682 fi
1435 read || die "something is screwed with your system" 1683 read || die "something is screwed with your system"
1436 done 1684 done
1437} 1685}
1438 1686
1687# @FUNCTION: strip-linguas
1688# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1689# @DESCRIPTION:
1439# Make sure that LINGUAS only contains languages that 1690# Make sure that LINGUAS only contains languages that
1440# a package can support 1691# a package can support. The first form allows you to
1441# 1692# specify a list of LINGUAS. The -i builds a list of po
1442# usage: strip-linguas <allow LINGUAS> 1693# files found in all the directories and uses the
1443# strip-linguas -i <directories of .po files> 1694# intersection of the lists. The -u builds a list of po
1444# strip-linguas -u <directories of .po files> 1695# files found in all the directories and uses the union
1445# 1696# of the lists.
1446# The first form allows you to specify a list of LINGUAS.
1447# The -i builds a list of po files found in all the
1448# directories and uses the intersection of the lists.
1449# The -u builds a list of po files found in all the
1450# directories and uses the union of the lists.
1451strip-linguas() { 1697strip-linguas() {
1452 local ls newls nols 1698 local ls newls nols
1453 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1699 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1454 local op=$1; shift 1700 local op=$1; shift
1455 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1701 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1456 local d f 1702 local d f
1457 for d in "$@" ; do 1703 for d in "$@" ; do
1458 if [[ ${op} == "-u" ]] ; then 1704 if [[ ${op} == "-u" ]] ; then
1459 newls=${ls} 1705 newls=${ls}
1460 else 1706 else
1461 newls="" 1707 newls=""
1462 fi 1708 fi
1463 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1709 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1464 if [[ ${op} == "-i" ]] ; then 1710 if [[ ${op} == "-i" ]] ; then
1465 hasq ${f} ${ls} && newls="${newls} ${f}" 1711 hasq ${f} ${ls} && newls="${newls} ${f}"
1466 else 1712 else
1467 hasq ${f} ${ls} || newls="${newls} ${f}" 1713 hasq ${f} ${ls} || newls="${newls} ${f}"
1468 fi 1714 fi
1480 newls="${newls} ${f}" 1726 newls="${newls} ${f}"
1481 else 1727 else
1482 nols="${nols} ${f}" 1728 nols="${nols} ${f}"
1483 fi 1729 fi
1484 done 1730 done
1485 [[ -n ${newls} ]] \ 1731 [[ -n ${nols} ]] \
1486 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1732 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1487 export LINGUAS=${newls:1} 1733 export LINGUAS=${newls:1}
1488} 1734}
1489 1735
1490# moved from kernel.eclass since they are generally useful outside of 1736# @FUNCTION: preserve_old_lib
1491# kernel.eclass -iggy (20041002) 1737# @USAGE: <libs to preserve> [more libs]
1492 1738# @DESCRIPTION:
1493# the following functions are useful in kernel module ebuilds, etc.
1494# for an example see ivtv or drbd ebuilds
1495
1496# set's ARCH to match what the kernel expects
1497set_arch_to_kernel() {
1498 i=10
1499 while ((i--)) ; do
1500 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1501 done
1502 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1503 case ${ARCH} in
1504 x86) export ARCH="i386";;
1505 amd64) export ARCH="x86_64";;
1506 hppa) export ARCH="parisc";;
1507 mips) export ARCH="mips";;
1508 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1509 *) export ARCH="${ARCH}";;
1510 esac
1511}
1512
1513# set's ARCH back to what portage expects
1514set_arch_to_portage() {
1515 i=10
1516 while ((i--)) ; do
1517 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1518 done
1519 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1520}
1521
1522# Jeremy Huddleston <eradicator@gentoo.org>:
1523# preserve_old_lib /path/to/libblah.so.0
1524# preserve_old_lib_notify /path/to/libblah.so.0
1525#
1526# These functions are useful when a lib in your package changes --library. Such 1739# These functions are useful when a lib in your package changes ABI SONAME.
1527# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1740# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1528# would break packages that link against it. Most people get around this 1741# would break packages that link against it. Most people get around this
1529# by using the portage SLOT mechanism, but that is not always a relevant 1742# by using the portage SLOT mechanism, but that is not always a relevant
1530# solution, so instead you can add the following to your ebuilds: 1743# solution, so instead you can call this from pkg_preinst. See also the
1531# 1744# preserve_old_lib_notify function.
1532# src_install() {
1533# ...
1534# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1535# ...
1536# }
1537#
1538# pkg_postinst() {
1539# ...
1540# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1541# ...
1542# }
1543
1544preserve_old_lib() { 1745preserve_old_lib() {
1545 LIB=$1 1746 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1747 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1748 die "Invalid preserve_old_lib() usage"
1749 fi
1750 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1546 1751
1547 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1752 # let portage worry about it
1548 SONAME=`basename ${LIB}` 1753 has preserve-libs ${FEATURES} && return 0
1549 DIRNAME=`dirname ${LIB}`
1550 1754
1551 dodir ${DIRNAME} 1755 local lib dir
1552 cp ${ROOT}${LIB} ${D}${DIRNAME} 1756 for lib in "$@" ; do
1757 [[ -e ${ROOT}/${lib} ]] || continue
1758 dir=${lib%/*}
1759 dodir ${dir} || die "dodir ${dir} failed"
1760 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1553 touch ${D}${LIB} 1761 touch "${D}"/${lib}
1554 fi 1762 done
1555} 1763}
1556 1764
1765# @FUNCTION: preserve_old_lib_notify
1766# @USAGE: <libs to notify> [more libs]
1767# @DESCRIPTION:
1768# Spit helpful messages about the libraries preserved by preserve_old_lib.
1557preserve_old_lib_notify() { 1769preserve_old_lib_notify() {
1558 LIB=$1 1770 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1771 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1772 die "Invalid preserve_old_lib_notify() usage"
1773 fi
1559 1774
1560 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1775 # let portage worry about it
1561 SONAME=`basename ${LIB}` 1776 has preserve-libs ${FEATURES} && return 0
1562 1777
1778 local lib notice=0
1779 for lib in "$@" ; do
1780 [[ -e ${ROOT}/${lib} ]] || continue
1781 if [[ ${notice} -eq 0 ]] ; then
1782 notice=1
1563 ewarn "An old version of an installed library was detected on your system." 1783 ewarn "Old versions of installed libraries were detected on your system."
1564 ewarn "In order to avoid breaking packages that link against it, this older version" 1784 ewarn "In order to avoid breaking packages that depend on these old libs,"
1565 ewarn "is not being removed. In order to make full use of this newer version," 1785 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1566 ewarn "you will need to execute the following command:" 1786 ewarn "in order to remove these old dependencies. If you do not have this"
1787 ewarn "helper program, simply emerge the 'gentoolkit' package."
1788 ewarn
1789 fi
1567 ewarn " revdep-rebuild --library ${SONAME}" 1790 ewarn " # revdep-rebuild --library ${lib##*/}"
1791 done
1792 if [[ ${notice} -eq 1 ]] ; then
1568 ewarn 1793 ewarn
1569 ewarn "After doing that, you can safely remove ${LIB}" 1794 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1570 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1795 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1796 for lib in "$@" ; do
1797 ewarn " # rm '${lib}'"
1798 done
1571 fi 1799 fi
1572} 1800}
1573 1801
1574# Hack for people to figure out if a package was built with 1802# @FUNCTION: built_with_use
1575# certain USE flags 1803# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1804# @DESCRIPTION:
1576# 1805#
1577# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1806# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1578# ex: built_with_use xchat gtk2
1579# 1807#
1580# Flags: -a all USE flags should be utilized 1808# A temporary hack until portage properly supports DEPENDing on USE
1581# -o at least one USE flag should be utilized 1809# flags being enabled in packages. This will check to see if the specified
1582# Note: the default flag is '-a' 1810# DEPEND atom was built with the specified list of USE flags. The
1811# --missing option controls the behavior if called on a package that does
1812# not actually support the defined USE flags (aka listed in IUSE).
1813# The default is to abort (call die). The -a and -o flags control
1814# the requirements of the USE flags. They correspond to "and" and "or"
1815# logic. So the -a flag means all listed USE flags must be enabled
1816# while the -o flag means at least one of the listed IUSE flags must be
1817# enabled. The --hidden option is really for internal use only as it
1818# means the USE flag we're checking is hidden expanded, so it won't be found
1819# in IUSE like normal USE flags.
1820#
1821# Remember that this function isn't terribly intelligent so order of optional
1822# flags matter.
1583built_with_use() { 1823built_with_use() {
1824 local hidden="no"
1825 if [[ $1 == "--hidden" ]] ; then
1826 hidden="yes"
1827 shift
1828 fi
1829
1830 local missing_action="die"
1831 if [[ $1 == "--missing" ]] ; then
1832 missing_action=$2
1833 shift ; shift
1834 case ${missing_action} in
1835 true|false|die) ;;
1836 *) die "unknown action '${missing_action}'";;
1837 esac
1838 fi
1839
1584 local opt=$1 1840 local opt=$1
1585 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1841 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1586 1842
1587 local PKG=$(best_version $1) 1843 local PKG=$(best_version $1)
1844 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1588 shift 1845 shift
1589 1846
1590 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1847 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1848 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1591 1849
1592 # if the USE file doesnt exist, assume the $PKG is either 1850 # if the IUSE file doesn't exist, the read will error out, we need to handle
1593 # injected or package.provided 1851 # this gracefully
1594 [[ ! -e ${USEFILE} ]] && return 0 1852 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1853 case ${missing_action} in
1854 true) return 0;;
1855 false) return 1;;
1856 die) die "Unable to determine what USE flags $PKG was built with";;
1857 esac
1858 fi
1859
1860 if [[ ${hidden} == "no" ]] ; then
1861 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1862 # Don't check USE_EXPAND #147237
1863 local expand
1864 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1865 if [[ $1 == ${expand}_* ]] ; then
1866 expand=""
1867 break
1868 fi
1869 done
1870 if [[ -n ${expand} ]] ; then
1871 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1872 case ${missing_action} in
1873 true) return 0;;
1874 false) return 1;;
1875 die) die "$PKG does not actually support the $1 USE flag!";;
1876 esac
1877 fi
1878 fi
1879 fi
1595 1880
1596 local USE_BUILT=$(<${USEFILE}) 1881 local USE_BUILT=$(<${USEFILE})
1597 while [[ $# -gt 0 ]] ; do 1882 while [[ $# -gt 0 ]] ; do
1598 if [[ ${opt} = "-o" ]] ; then 1883 if [[ ${opt} = "-o" ]] ; then
1599 has $1 ${USE_BUILT} && return 0 1884 has $1 ${USE_BUILT} && return 0
1603 shift 1888 shift
1604 done 1889 done
1605 [[ ${opt} = "-a" ]] 1890 [[ ${opt} = "-a" ]]
1606} 1891}
1607 1892
1893# @FUNCTION: epunt_cxx
1894# @USAGE: [dir to scan]
1895# @DESCRIPTION:
1608# Many configure scripts wrongly bail when a C++ compiler 1896# Many configure scripts wrongly bail when a C++ compiler could not be
1609# could not be detected. #73450 1897# detected. If dir is not specified, then it defaults to ${S}.
1898#
1899# http://bugs.gentoo.org/73450
1610epunt_cxx() { 1900epunt_cxx() {
1611 local dir=$1 1901 local dir=$1
1612 [[ -z ${dir} ]] && dir=${S} 1902 [[ -z ${dir} ]] && dir=${S}
1613 ebegin "Removing useless C++ checks" 1903 ebegin "Removing useless C++ checks"
1614 local f 1904 local f
1615 for f in $(find ${dir} -name configure) ; do 1905 find "${dir}" -name configure | while read f ; do
1616 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1906 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1617 done 1907 done
1618 eend 0 1908 eend 0
1619} 1909}
1620 1910
1621# dopamd <file> [more files] 1911# @FUNCTION: make_wrapper
1622# 1912# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1623# Install pam auth config file in /etc/pam.d 1913# @DESCRIPTION:
1624dopamd() { 1914# Create a shell wrapper script named wrapper in installpath
1625 [[ -z $1 ]] && die "dopamd requires at least one argument" 1915# (defaults to the bindir) to execute target (default of wrapper) by
1626 1916# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1627 use pam || return 0 1917# libpaths followed by optionally changing directory to chdir.
1628
1629 INSDESTTREE=/etc/pam.d \
1630 doins "$@" || die "failed to install $@"
1631}
1632# newpamd <old name> <new name>
1633#
1634# Install pam file <old name> as <new name> in /etc/pam.d
1635newpamd() {
1636 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1637
1638 use pam || return 0
1639
1640 INSDESTTREE=/etc/pam.d \
1641 newins "$1" "$2" || die "failed to install $1 as $2"
1642}
1643
1644# make a wrapper script ...
1645# NOTE: this was originally games_make_wrapper, but I noticed other places where
1646# this could be used, so I have moved it here and made it not games-specific
1647# -- wolf31o2
1648# $1 == wrapper name
1649# $2 == binary to run
1650# $3 == directory to chdir before running binary
1651# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1652# $5 == path for wrapper
1653make_wrapper() { 1918make_wrapper() {
1654 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1919 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1655 local tmpwrapper=$(emktemp) 1920 local tmpwrapper=$(emktemp)
1656 # We don't want to quote ${bin} so that people can pass complex 1921 # We don't want to quote ${bin} so that people can pass complex
1657 # things as $bin ... "./someprog --args" 1922 # things as $bin ... "./someprog --args"
1667fi 1932fi
1668exec ${bin} "\$@" 1933exec ${bin} "\$@"
1669EOF 1934EOF
1670 chmod go+rx "${tmpwrapper}" 1935 chmod go+rx "${tmpwrapper}"
1671 if [[ -n ${path} ]] ; then 1936 if [[ -n ${path} ]] ; then
1937 (
1672 exeinto "${path}" 1938 exeinto "${path}"
1673 newexe "${tmpwrapper}" "${wrapper}" 1939 newexe "${tmpwrapper}" "${wrapper}"
1940 ) || die
1674 else 1941 else
1675 newbin "${tmpwrapper}" "${wrapper}" 1942 newbin "${tmpwrapper}" "${wrapper}" || die
1943 fi
1944}
1945
1946# @FUNCTION: prepalldocs
1947# @USAGE:
1948# @DESCRIPTION:
1949# Compress files in /usr/share/doc which are not already
1950# compressed, excluding /usr/share/doc/${PF}/html.
1951# Uses the ecompressdir to do the compression.
1952# 2009-02-18 by betelgeuse:
1953# Commented because ecompressdir is even more internal to
1954# Portage than prepalldocs (it's not even mentioned in man 5
1955# ebuild). Please submit a better version for review to gentoo-dev
1956# if you want prepalldocs here.
1957#prepalldocs() {
1958# if [[ -n $1 ]] ; then
1959# ewarn "prepalldocs: invalid usage; takes no arguments"
1676 fi 1960# fi
1677} 1961
1962# cd "${D}"
1963# [[ -d usr/share/doc ]] || return 0
1964
1965# find usr/share/doc -exec gzip {} +
1966# ecompressdir --ignore /usr/share/doc/${PF}/html
1967# ecompressdir --queue /usr/share/doc
1968#}

Legend:
Removed from v.1.243  
changed lines
  Added in v.1.349

  ViewVC Help
Powered by ViewVC 1.1.20